3 remotes_git_svn=remotes/git""-svn
4 git_svn_id=git""-svn-id
6 if test -n "$NO_SVN_TESTS"
8 skip_all='skipping git svn tests, NO_SVN_TESTS defined'
11 if ! test_have_prereq PERL; then
12 skip_all='skipping git svn tests, perl not available'
17 GIT_SVN_DIR=$GIT_DIR/svn/refs/remotes/git-svn
18 SVN_TREE=$GIT_SVN_DIR/svn-tree
23 skip_all='skipping git svn tests, svn not found'
35 \$SVN::Core::VERSION gt '1.1.0' or exit(42);
36 system(qw/svnadmin create --fs-type fsfs/, \$ENV{svnrepo}) == 0 or exit(41);
41 if test $x -eq 42; then
42 skip_all='Perl SVN libraries must be >= 1.1.0'
43 elif test $x -eq 41; then
44 skip_all='svnadmin failed to create fsfs repository'
46 skip_all='Perl SVN libraries not found or unusable'
52 svnrepo="file://$svnrepo"
58 # We need this, because we should pass empty configuration directory to
59 # the 'svn commit' to avoid automated property changes and other stuff
60 # that could be set from user's configuration files in ~/.subversion.
62 [ -d "$svnconf" ] || mkdir "$svnconf"
63 orig_svncmd="$1"; shift
64 if [ -z "$orig_svncmd" ]; then
68 svn "$orig_svncmd" --config-dir "$svnconf" "$@"
83 if test -z "$SVN_HTTPD_PATH"
85 echo >&2 '*** error: Apache not found'
89 "$SVN_HTTPD_MODULE_PATH" \
90 /usr/lib/apache2/modules \
91 /usr/libexec/apache2 \
95 SVN_HTTPD_MODULE_PATH="$d"
99 if test -z "$SVN_HTTPD_MODULE_PATH"
101 echo >&2 '*** error: Apache module dir not found'
104 if test ! -f "$SVN_HTTPD_MODULE_PATH/mod_dav_svn.so"
106 echo >&2 '*** error: Apache module "mod_dav_svn" not found'
110 repo_base_path="${1-svn}"
111 mkdir "$GIT_DIR"/logs
113 cat > "$GIT_DIR/httpd.conf" <<EOF
114 ServerName "git svn test"
115 ServerRoot "$GIT_DIR"
116 DocumentRoot "$GIT_DIR"
117 PidFile "$GIT_DIR/httpd.pid"
118 LockFile logs/accept.lock
119 Listen 127.0.0.1:$SVN_HTTPD_PORT
120 LoadModule dav_module $SVN_HTTPD_MODULE_PATH/mod_dav.so
121 LoadModule dav_svn_module $SVN_HTTPD_MODULE_PATH/mod_dav_svn.so
122 <Location /$repo_base_path>
124 SVNPath "$rawsvnrepo"
130 if test -z "$SVN_HTTPD_PORT"
132 echo >&2 'SVN_HTTPD_PORT is not defined!'
136 prepare_httpd "$1" || return 1
138 "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k start
139 svnrepo="http://127.0.0.1:$SVN_HTTPD_PORT/$repo_base_path"
143 test -z "$SVN_HTTPD_PORT" && return
144 test ! -f "$GIT_DIR/httpd.conf" && return
145 "$SVN_HTTPD_PATH" -f "$GIT_DIR"/httpd.conf -k stop
148 convert_to_rev_db () {
149 "$PERL_PATH" -w -- - "$@" <<\EOF
151 @ARGV == 2 or die "Usage: convert_to_rev_db <input> <output>";
152 open my $wr, '+>', $ARGV[1] or die "$!: couldn't open: $ARGV[1]";
153 open my $rd, '<', $ARGV[0] or die "$!: couldn't open: $ARGV[0]";
154 my $size = (stat($rd))[7];
155 ($size % 24) == 0 or die "Inconsistent size: $size";
156 while (sysread($rd, my $buf, 24) == 24) {
157 my ($r, $c) = unpack('NH40', $buf);
158 my $offset = $r * 41;
159 seek $wr, 0, 2 or die $!;
161 if ($pos < $offset) {
162 for (1 .. (($offset - $pos) / 41)) {
163 print $wr (('0' x 40),"\n") or die $!;
166 seek $wr, $offset, 0 or die $!;
167 print $wr $c,"\n" or die $!;
174 require_svnserve () {
175 if test -z "$SVNSERVE_PORT"
177 skip_all='skipping svnserve test. (set $SVNSERVE_PORT to enable)'
183 svnserve --listen-port $SVNSERVE_PORT \
184 --root "$rawsvnrepo" \
186 --listen-host 127.0.0.1 &